// $Id$

/***************************************************************************
*   Copyright (C) 2004 by Thomas Fischer                                  *
*   fischer@unix-ag.uni-kl.de                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef KBIBTEXENTRYWIDGET_H
#define KBIBTEXENTRYWIDGET_H

#include <qwidget.h>

class KComboBox;
class QLineEdit;
class QTabWidget;
class QFrame;
class KPushButton;
class KLineEdit;
class KListBox;
class QListBoxItem;
class QSpinBox;
class QPushButton;
class KTextEdit;
class KHistoryCombo;
class KListView;
class QListViewItem;
class QStringList;
class BibTeXEntry;
class BibTeXFile;
class KBibTeXEditListBox;
class QTextEdit;
class QCheckBox;

/**
@author Thomas Fischer
*/
class KBibTeXEntryWidget : public QWidget
{
    Q_OBJECT

public:
    KBibTeXEntryWidget( BibTeXEntry *entry, BibTeXFile *bibtexfile, QWidget *parent = 0, const char *name = 0 );

    ~KBibTeXEntryWidget();

    static QDialog::DialogCode execute( BibTeXEntry *entry, BibTeXFile *bibtexfile, const QString& caption, QWidget *parent = 0, const char *name = 0 );

protected:
    KComboBox* kComboBoxEntryType;
    QLineEdit* lineEditID;
    QLineEdit* lineEditTitle;
    QLineEdit* lineEditBookTitle;
    QLineEdit* lineEditSeries;
    KBibTeXEditListBox *elbAuthor;
    KBibTeXEditListBox *elbEditor;
    QLineEdit* lineEditPages;
    QSpinBox* spinBoxVolume;
    QSpinBox* spinBoxEdition;
    KComboBox* kComboBoxMonth;
    QSpinBox* spinBoxYear;
    QLineEdit* lineEditChapter;
    KLineEdit* kLineEditNumber;
    KLineEdit* kLineEditOrganization;
    KLineEdit* kLineEditSchool;
    KLineEdit* kLineEditCrossRef;
    KLineEdit* kLineEditPublisher;
    KLineEdit* kLineEditInstitution;
    KLineEdit* kLineEditAddress;
    KLineEdit* kLineEditHowPublished;
    KLineEdit* kLineEditISBN;
    KLineEdit* kLineEditISSN;
    KLineEdit* kLineEditJournal;
    QWidget* TabPage_2;
    QLabel* textLabelType;
    QLineEdit* lineEditKey;
    QLabel* textLabelKey;
    QLabel* textLabelNote;
    QLineEdit* lineEditNote;
    QLineEdit* lineEditType;
    QLabel* textLabelAnnote;
    QLineEdit* lineEditAnnote;
    QLabel* textLabelURL;
    QLineEdit* lineEditURL;
    KPushButton* kPushButtonURLtoNote;
    QLabel* textLabelAbstract;
    KTextEdit* kTextEditAbstract;
    QWidget* TabPage_3;
    KPushButton* kPushButtonUserDelete;
    QLabel* textLabelUserKey;
    QLabel* textLabelUserValue;
    KHistoryCombo* kHistoryComboUserName;
    KPushButton* kPushButtonUserAdd;
    KListView* kListViewUserFields;
    KTextEdit* kTextEditUserValue;
    QTextEdit *textEditSource;
    QCheckBox *checkBoxSourceHighlightning;
    QWidget *sourceTab;

private:
    enum WidgetStatus {wsRequired, wsOptional, wsUnused};
    BibTeXEntry *m_entry;
    BibTeXFile *m_bibtexfile;
    bool m_enableAllFields, m_sourcehighlighting;
    QStringList *deletedUserFields;

    void setupGUI();
    void setupEntryTypes();
    void getEntryData();
    bool setEntryDataSpinBox( BibTeXEntry *entry, QSpinBox *sbx, BibTeXEntry::FieldType fieldType );
    bool setEntryDataText( BibTeXEntry *entry, QString text, BibTeXEntry::FieldType fieldType );
    bool setEntryData( BibTeXEntry *entry );
    void changeElementType( BibTeXElement::ElementType elementType );
    void setWidgetStatus( QWidget* widget, BibTeXEntry::FieldRequireStatus requiredStatus );
    void getUserFields();
    void refreshSourceView();

private slots:
    void slotOk();
    void slotEntryTypeChanged( int index );
    void slotEnableAllFields( bool enable );
    void slotUserFieldExecute( QListViewItem* item = NULL );
    void slotUserNameChanged( const QString& newText );
    void slotUserAddClicked( );
    void slotUserDeleteClicked();
    void slotApplyURLtoNode();
    void slotSelectStringJournal();
    void slotCurrentTabChanged( QWidget* newTab );
    void slotSourceHighlightningToggle( bool highlight );
};

#endif
