// $Id$

/***************************************************************************
*   Copyright (C) 2004 by Thomas Fischer                                  *
*   fischer@unix-ag.uni-kl.de                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include <qstring.h>

#include "kbibtexfieldlistviewitem.h"

KBibTeXFieldListViewItem::KBibTeXFieldListViewItem( BibTeXEntry::FieldType fieldType, QString fieldName, QString fieldValue, QListView *parent, const char* name )
        : KListViewItem( parent, name ), m_fieldType( fieldType ), m_fieldName( fieldName ), m_fieldValue( fieldValue )
{
    setTexts();
}


KBibTeXFieldListViewItem::~KBibTeXFieldListViewItem()
{}

BibTeXEntry::FieldType KBibTeXFieldListViewItem::fieldType()
{
    return m_fieldType;
}

QString KBibTeXFieldListViewItem::fieldName()
{
    return m_fieldName;
}

QString KBibTeXFieldListViewItem::fieldValue()
{
    return m_fieldValue;
}

void KBibTeXFieldListViewItem::setFieldType( BibTeXEntry::FieldType fieldType )
{
    m_fieldType = fieldType;
}

void KBibTeXFieldListViewItem::setFieldName( QString fieldName )
{
    m_fieldName = fieldName;
}

void KBibTeXFieldListViewItem::setFieldValue( QString fieldValue )
{
    m_fieldValue = fieldValue;
}

void KBibTeXFieldListViewItem::updateItem()
{
    setTexts();
}

void KBibTeXFieldListViewItem::setTexts()
{
    setText( 0, m_fieldName );
    setText( 1, m_fieldValue );
}
